#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define PI 3.14159265358979323846

#ifndef MATRIX
#define MATRIX 1
#include "matrix.h"
#endif

extern int spl(int length, int NFFT, int shift);
extern void specgram(vector x, int spl, int length, int shift, int NFFT, 
		     matrix spr, matrix spi);
extern int ispl(int spl, int NFFT, int shift);
extern void ispecgram(vector x, int spl, int length, int shift, int NFFT, 
		      vector w, matrix spr, matrix spi);
extern void hamming(int length, vector w);
extern void hanning(int length, vector w);
extern void rectangle(int length, vector w);
extern int fft(int n, vector x, vector y);
int conv(int f_size, int d_size, vector fil, vector x, vector output);
